diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
index 18c3dc302..3e1a09e98 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.entity;
 
 import java.util.List;
+import java.util.Objects;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.achievement.Achievements;
@@ -8,6 +9,8 @@ import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicLog;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.TileEntityMesh;
+import net.minecraft.core.block.entity.TileEntityMeshGold;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.player.Player;
@@ -16,6 +19,7 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
@@ -27,12 +31,13 @@ public class EntityItem extends Entity
     public ItemStack item;
     public int lifetime;
     public int age;
+    public Direction siphonDirection = Direction.NONE;
+    public TileEntityMesh meshSiphoning = null;
     public int pickupDelay;
     private int health;
     public float bobOffset;
     public int basketPickupDelay = 0;
     public static boolean enableItemClumping = true;
-    private final TilePos queryPos = new TilePos();
 
     public EntityItem(@NotNull World world, double x, double y, double z, @NotNull ItemStack itemstack) {
         super(world);
@@ -95,37 +100,25 @@ public class EntityItem extends Entity
         {
             this.pickupDelay--;
         }
-        boolean inLava = isInLava();
+
+        final TilePos tilePosUnderItem = new TilePos(this.x, this.y - 1, this.z);
+        final TilePos tilePosItemIsInside = new TilePos(this.x, this.y, this.z);
+        final @NotNull Block<?> blockUnderItem = this.world.getBlockType(tilePosUnderItem);
+        final @NotNull Block<?> blockItemIsIn = this.world.getBlockType(tilePosItemIsInside);
+
+        boolean isInFlowingWater = false;
+        if(blockItemIsIn == Blocks.FLUID_WATER_STILL)
+        {
+            isInFlowingWater = Blocks.FLUID_WATER_STILL.getLogic().hasFlowVector(this.world, new TilePos(this.x, this.y, this.z));
+        }
+
+        handleFriction(blockUnderItem, blockItemIsIn, isInFlowingWater);
+        handleBuoyancy(blockUnderItem, tilePosUnderItem, isInFlowingWater);
+
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
-        boolean throughBelow = !this.world.getBlockType(this.queryPos.set(MathHelper.floor(this.x), MathHelper.floor(this.y) - 1, MathHelper.floor(this.z))).collidesWithEntity(this, this.world, this.queryPos);
-        if (this.item.getItem().hasTag(ItemTags.IS_FIRE_PROOF)) {
-            if (((this.wasInWater || inLava) && !throughBelow)) {
-                this.yd += 0.02D;
-            } else if (this.wasInWater || inLava){
-                this.yd += (-0.04D * 3.5);
-            } else {
-                this.yd += (-0.04D * 1);
-            }
-        } else {
-
-            if ((this.wasInWater && !throughBelow)) {
-                this.yd += 0.02D;
-            } else if (this.wasInWater) {
-                this.yd += (-0.04D * 3.5);
-            } else {
-                this.yd += (-0.04D * 1);
-            }
 
-            if(isInLava())
-            {
-                this.yd = 0.2D;
-                this.xd = (this.random.nextFloat() - this.random.nextFloat()) * 0.2F;
-                this.zd = (this.random.nextFloat() - this.random.nextFloat()) * 0.2F;
-                this.world.playSoundAtEntity(null, this, "random.fizz", 0.4F, 2.0F + this.random.nextFloat() * 0.4F);
-            }
-        }
         checkAndPushInTile(this.x, (this.bb.minY + this.bb.maxY) / 2D, this.z);
         move(this.xd, this.yd, this.zd);
         
@@ -136,34 +129,7 @@ public class EntityItem extends Entity
                 }		
         	}
         }
-        
-        float friction = 0.98F;
-        if(this.onGround)
-        {
-            friction = 0.588F;
-            int blockId = this.world.getBlockId(MathHelper.floor(this.x), MathHelper.floor(this.bb.minY) - 1, MathHelper.floor(this.z));
-            if(blockId > 0)
-            {
-                friction = Blocks.blocksList[blockId].friction * 0.98F;
-            }
-        }
-        this.xd *= friction;
-        this.yd *= 0.98D;
-        this.zd *= friction;
-
-        if (this.wasInWater)
-        {
-            if(this.yd < 0.0f) {
-                this.xd *= 0.95f;
-                this.yd *= 0.45f;
-                this.zd *= 0.95f;
-            }
-        }
 
-        if(this.onGround)
-        {
-            this.yd *= -0.5D;
-        }
         this.age++;
         if(this.age >= this.lifetime && this.lifetime >= 0 && !this.item.getItem().hasTag(ItemTags.IS_PERSISTENT)) // Negative lifetime indicates items should last forever
         {
@@ -323,6 +289,114 @@ public class EntityItem extends Entity
     		}
     	}
     }
+
+    private void handleFriction(@NotNull Block<?> blockUnderItem, @NotNull Block<?> blockItemIsIn, boolean isInFlowingWater){
+
+        //All mentions of friction in comments use the ENGLISH sense of the word, as for some reason
+        //  adding friction to any value in game actually LOWERS the literal friction the item is receiving, and vice versa
+        float friction = 0.98F;
+
+        //Set friction of item to the block below it (unless in air)
+        if(this.onGround)
+        {
+            friction = 0.588F;
+            if(blockUnderItem.getMaterial() != Materials.AIR){
+                friction = blockUnderItem.friction;
+            }
+        }
+
+        //Items in streams of water get their friction set to the block underneath them/the stream.
+        //All blocks get are given significantly less friction, and ice is given slightly less friction to
+        //  improve the efficiency/speed of each respective water stream
+        if(isInFlowingWater)
+        {
+            if(blockUnderItem != Blocks.FLUID_WATER_STILL)
+            {
+                friction = blockUnderItem.friction;
+            }
+
+            if(blockUnderItem.getMaterial() != Materials.ICE)
+            {
+                friction += 0.3f;
+            }
+            else
+            {
+                friction *= 1.005f;
+            }
+        }
+
+        this.xd *= friction;
+        this.yd *= 0.98D;
+        this.zd *= friction;
+
+    }
+
+    private void handleBuoyancy(Block<?> blockUnderItem, TilePos tilePosUnderItem, boolean inFlowingLiquid){
+
+        double midpoint = this.y % 1d + 0.14;
+        float fluidHeight = Blocks.FLUID_WATER_STILL.getLogic().getFluidHeight(this.world, new TilePos(this.x, this.y, this.z));
+
+        //Adjust the height at which the item believes itself to be in the water for buoyancy purposes
+        //  (so that the bobbing height is closer to the center of its bb)
+        boolean isInWater = false;
+        if(fluidHeight > midpoint || fluidHeight == 1){
+            isInWater = this.isInWater();
+        }
+
+        //self-explanatory :wolfblock:
+        if (isInWater)
+        {
+            //gradually slows the item down laterally
+            this.xd *= 0.98f;
+            this.zd *= 0.98f;
+
+            //if not in flowing liquid, float upwards gradually
+            if(!inFlowingLiquid)
+            {
+                this.yd += 0.001;
+            }
+
+            if(blockUnderItem == Blocks.MESH)
+            {
+                this.yd -= 0.02D;
+            }
+
+            if(blockUnderItem == Blocks.MESH_GOLD)
+            {
+                ItemStack filterItem = ((TileEntityMeshGold) Objects.requireNonNull(world.getTileEntity(tilePosUnderItem))).filterItem;
+                if(filterItem != null){
+                    if (this.item.getItem() == filterItem.getItem() && this.item.getMetadata() == filterItem.getMetadata()){
+                        this.yd -= 0.02D;
+                    }
+                }
+            }
+        }
+        //gravity out of water
+        else
+        {
+            this.yd -= 0.04D;
+        }
+
+
+
+/*        if (item.getItem().hasTag(ItemTags.IS_FIRE_PROOF)) {
+            this.yd += (this.wasInWater || inLava) ? 0.001D : -0.04D;
+        } else {
+            this.yd += this.wasInWater ? 0.001D : -0.04D;
+
+            if(isInLava())
+            {
+                this.yd = 0.2D;
+                this.xd = (this.random.nextFloat() - this.random.nextFloat()) * 0.2F;
+                this.zd = (this.random.nextFloat() - this.random.nextFloat()) * 0.2F;
+                this.world.playSoundAtEntity(null, this, "random.fizz", 0.4F, 2.0F + this.random.nextFloat() * 0.4F);
+            }
+        }*/
+    }
+
+    public boolean isBeingSiphoned(){
+        return siphonDirection != Direction.NONE;
+    }
     
     private static void combineItems(EntityItem entityItem1, EntityItem entityItem2) {
     	entityItem1.item.stackSize += entityItem2.item.stackSize;
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index f84c19180..7ae6a7b18 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -1491,12 +1491,12 @@ public abstract class World implements MutableWorldSource {
         this.updatingTileEntities = true;
         for (int i = this.tileEntityList.size() - 1; i >= 0; i--) {
             final TileEntity tileEntity = this.tileEntityList.get(i);
-            if (!tileEntity.isInvalid() && this.isBlockLoaded(tileEntity.x, tileEntity.y, tileEntity.z)) {
+            if (!tileEntity.isInvalid() && this.isBlockLoaded(tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z)) {
                 tileEntity.tick();
             }
             if (tileEntity.isInvalid()) {
                 this.tileEntityList.remove(i);
-                final Chunk chunk = this.getChunkFromChunkCoords(Math.floorDiv(tileEntity.x, Chunk.CHUNK_SIZE_X), Math.floorDiv(tileEntity.z, Chunk.CHUNK_SIZE_Z));
+                final Chunk chunk = this.getChunkFromChunkCoords(Math.floorDiv(tileEntity.tilePos.x, Chunk.CHUNK_SIZE_X), Math.floorDiv(tileEntity.tilePos.z, Chunk.CHUNK_SIZE_Z));
                 if (chunk != null) {
                     chunk.removeTileEntity(tileEntity);
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index 472c9b5ed..467d406c1 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -609,7 +609,7 @@ public class Chunk {
     }
 
     public void addTileEntity(final @NotNull TileEntity tileEntity) {
-        final @NotNull TilePos tilePos = new TilePos(tileEntity.x, tileEntity.y, tileEntity.z);
+        final @NotNull TilePos tilePos = new TilePos(tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z);
 
         this.setTileEntity(new ChunkTilePos(tilePos), tileEntity);
         if (this.isLoaded) {
@@ -624,9 +624,9 @@ public class Chunk {
         final @NotNull TilePos worldPos = new TilePos(this.pos, tilePos);
 
         tileEntity.worldObj = this.world;
-        tileEntity.x = worldPos.x;
-        tileEntity.y = worldPos.y;
-        tileEntity.z = worldPos.z;
+        tileEntity.tilePos.x = worldPos.x;
+        tileEntity.tilePos.y = worldPos.y;
+        tileEntity.tilePos.z = worldPos.z;
 
         final @Nullable Block<?> block = this.getBlock(tilePos);
         if (!block.isEntityTile) {
@@ -669,7 +669,7 @@ public class Chunk {
 
     public void removeTileEntity(@Nullable TileEntity tileEntity) {
         if (this.isLoaded && tileEntity != null && this.tileEntityMap.containsValue(tileEntity)) {
-            final @NotNull ChunkTilePos tilePos = new ChunkTilePos(tileEntity.x, tileEntity.y, tileEntity.z);
+            final @NotNull ChunkTilePos tilePos = new ChunkTilePos(tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z);
             this.tileEntityMap.remove(tilePos);
             tileEntity.invalidate();
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
index bf17d9bf7..b61afb705 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
@@ -53,9 +53,9 @@ public class DisplayChunk extends EmptyChunk{
         if (tilePos.x() == displayBlockPosX && tilePos.y() == displayBlockPosY && tilePos.z() == displayBlockPosZ) {
             displayTileEntity = tileEntity;
             displayTileEntity.worldObj = this.world;
-            displayTileEntity.x = tilePos.x();
-            displayTileEntity.y = tilePos.y();
-            displayTileEntity.z = tilePos.z();
+            displayTileEntity.tilePos.x = tilePos.x();
+            displayTileEntity.tilePos.y = tilePos.y();
+            displayTileEntity.tilePos.z = tilePos.z();
         }
 
         return true;
@@ -81,9 +81,9 @@ public class DisplayChunk extends EmptyChunk{
         displayTileEntity = entity;
         if (displayTileEntity != null){
             displayTileEntity.worldObj = world;
-            displayTileEntity.x = DisplayChunk.displayBlockPosX;
-            displayTileEntity.y = DisplayChunk.displayBlockPosY;
-            displayTileEntity.z = DisplayChunk.displayBlockPosZ;
+            displayTileEntity.tilePos.x = DisplayChunk.displayBlockPosX;
+            displayTileEntity.tilePos.y = DisplayChunk.displayBlockPosY;
+            displayTileEntity.tilePos.z = DisplayChunk.displayBlockPosZ;
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java b/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java
index ce758471b..866a571e9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java
@@ -170,8 +170,8 @@ public class ItemMapSavedData extends SavedData
         if(mapWaypoints.size() >= MAX_WAYPOINTS)
             return FlagError.FULL;
 
-        float xd = (float)(flag.x - (double) x) / (float)(1 << scale);
-        float zd = (float)(flag.z - (double) z) / (float)(1 << scale);
+        float xd = (float)(flag.tilePos.x - (double) x) / (float)(1 << scale);
+        float zd = (float)(flag.tilePos.z - (double) z) / (float)(1 << scale);
         int maxWidth = 64;
         int maxHeight = 64;
 
@@ -191,7 +191,7 @@ public class ItemMapSavedData extends SavedData
             }
         }
 
-        mapWaypoints.add(new MapWaypoint(xCoord, zCoord, flag.x, flag.y, flag.z, colors));
+        mapWaypoints.add(new MapWaypoint(xCoord, zCoord, flag.tilePos.x, flag.tilePos.y, flag.tilePos.z, colors));
         return FlagError.NONE;
     }
 
diff --git a/game/core/src/main/resources/lang/en_US/stats.lang b/game/core/src/main/resources/lang/en_US/stats.lang
index 8543920a4..1fafe463e 100644
--- a/game/core/src/main/resources/lang/en_US/stats.lang
+++ b/game/core/src/main/resources/lang/en_US/stats.lang
@@ -52,6 +52,8 @@ achievement.buildFurnace=Hot Topic
 achievement.buildFurnace.desc=Construct a furnace out of eight stone blocks.
 achievement.acquireIron=Acquire Hardware
 achievement.acquireIron.desc=Smelt an iron ingot.
+achievement.downTheDrain=Down the Drain
+achievement.downTheDrain.desc=Use a mesh block underwater to siphon items.
 achievement.buildHoe=Time to Farm!
 achievement.buildHoe.desc=Use planks and sticks to make a hoe.
 achievement.makeBread=Bake Bread
diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index b031a1053..e19d0734f 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -469,7 +469,7 @@ public class PlayerServer extends Player implements ContainerListener {
             playerNetServerHandler.sendPacket(new PacketSetRiding(this, (Entity) this.vehicle));
         } else if (vehicle instanceof TileEntity) {
             TileEntity tileEntity = (TileEntity) vehicle;
-            playerNetServerHandler.sendPacket(new PacketSetRiding(this, tileEntity.x, tileEntity.y, tileEntity.z));
+            playerNetServerHandler.sendPacket(new PacketSetRiding(this, tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z));
         }
         playerNetServerHandler.teleport(x, y, z);
     }
@@ -581,7 +581,7 @@ public class PlayerServer extends Player implements ContainerListener {
     public void displayFlagEditorScreen(TileEntityFlag tileEntity)
     {
         getNextWindowId();
-        playerNetServerHandler.sendPacket(new PacketFlagOpen(currentWindowId, tileEntity.x, tileEntity.y, tileEntity.z));
+        playerNetServerHandler.sendPacket(new PacketFlagOpen(currentWindowId, tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z));
         containerMenu.onCraftGuiClosed(this);
         containerMenu = new MenuFlag(inventory, tileEntity);
         containerMenu.containerId = currentWindowId;
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index 4d3a15a6e..c2a475017 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -761,12 +761,12 @@ public class PacketHandlerServer extends PacketHandler
                     System.arraycopy(packetCustomPayload.data, 1, flag.flagColors, 0, TileEntityFlag.CANVAS_WIDTH * TileEntityFlag.CANVAS_HEIGHT);
                     flag.setFlipped(flipped);
 
-                    this.playerEntity.world.markBlockNeedsUpdate(flag.x, flag.y, flag.z);
+                    this.playerEntity.world.markBlockNeedsUpdate(flag.tilePos.x, flag.tilePos.y, flag.tilePos.z);
                 } else {
                     LOGGER.warn("Player '{}' tried editing a flag that belongs to '{}'!", this.playerEntity.username, flag.owner);
 
                     // Let the client know that the flag design has been rejected
-                    this.playerEntity.world.markBlockNeedsUpdate(flag.x, flag.y, flag.z);
+                    this.playerEntity.world.markBlockNeedsUpdate(flag.tilePos.x, flag.tilePos.y, flag.tilePos.z);
                 }
             }
         } else if (PacketCustomPayload.CHANNEL_WAND_MONSTER.equals(packetCustomPayload.channel)) {
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index 869c23985..eb17bae0a 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -84,7 +84,7 @@ public class WorldServer extends World {
         for(int i = 0; i < tileEntityList.size(); i++)
         {
             TileEntity tileEntity = tileEntityList.get(i);
-            if(tileEntity.x >= minX && tileEntity.y >= minY && tileEntity.z >= minZ && tileEntity.x < maxX && tileEntity.y < maxY && tileEntity.z < maxZ)
+            if(tileEntity.tilePos.x >= minX && tileEntity.tilePos.y >= minY && tileEntity.tilePos.z >= minZ && tileEntity.tilePos.x < maxX && tileEntity.tilePos.y < maxY && tileEntity.tilePos.z < maxZ)
             {
                 arraylist.add(tileEntity);
             }
